'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const core = require('./core-99ee4b4e.js');

const Modal = class {
    constructor(hostRef) {
        core.registerInstance(this, hostRef);
        this.isActive = false;
    }
    async open() {
        this.isActive = true;
    }
    async close() {
        this.isActive = false;
    }
    async handleKeyUp(event) {
        if (this.isActive) {
            if (event.key === "Escape" || event.key === "Esc") {
                event.preventDefault();
                this.close();
            }
        }
    }
    render() {
        return (core.h(core.Host, null, core.h("div", { class: [
                "modal",
                "is-clipped",
                this.isActive ? "is-active" : "",
            ].join(" ") }, core.h("div", { class: "modal-background" }), core.h("div", { class: "modal-content" }, core.h("div", { class: "box" }, core.h("div", { class: "section" }, core.h("slot", null)))))));
    }
    static get style() { return ".modal-close{-webkit-touch-callout:none;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.box:not(:last-child){margin-bottom:1.5rem}.modal-close{-moz-appearance:none;-webkit-appearance:none;background-color:rgba(34,34,34,.2);border:none;border-radius:290486px;cursor:pointer;pointer-events:auto;display:inline-block;-webkit-box-flex:0;-ms-flex-positive:0;flex-grow:0;-ms-flex-negative:0;flex-shrink:0;font-size:0;height:20px;max-height:20px;max-width:20px;min-height:20px;min-width:20px;outline:none;position:relative;vertical-align:top;width:20px}.modal-close:after,.modal-close:before{background-color:#fff;content:\"\";display:block;left:50%;position:absolute;top:50%;-webkit-transform:translateX(-50%) translateY(-50%) rotate(45deg);transform:translateX(-50%) translateY(-50%) rotate(45deg);-webkit-transform-origin:center center;transform-origin:center center}.modal-close:before{height:2px;width:50%}.modal-close:after{height:50%;width:2px}.modal-close:focus,.modal-close:hover{background-color:rgba(34,34,34,.3)}.modal-close:active{background-color:rgba(34,34,34,.4)}.is-small.modal-close{height:16px;max-height:16px;max-width:16px;min-height:16px;min-width:16px;width:16px}.is-medium.modal-close{height:24px;max-height:24px;max-width:24px;min-height:24px;min-width:24px;width:24px}.is-large.modal-close{height:32px;max-height:32px;max-width:32px;min-height:32px;min-width:32px;width:32px}.modal,.modal-background{bottom:0;left:0;position:absolute;right:0;top:0}*{-webkit-box-sizing:border-box;box-sizing:border-box;-moz-osx-font-smoothing:grayscale;text-rendering:optimizeLegibility;-webkit-text-size-adjust:100%;-moz-text-size-adjust:100%}.section{padding:40px}\@media screen and (min-width:1024px){.section.is-medium{padding:9rem 1.5rem}.section.is-large{padding:18rem 1.5rem}}.box{background-color:#fff;border-radius:0;-webkit-box-shadow:0 0 10px 0 rgba(0,33,98,.15);box-shadow:0 0 10px 0 rgba(0,33,98,.15);color:#222;display:block;padding:0}a.box:active,a.box:focus,a.box:hover{-webkit-box-shadow:0 0 30px 0 rgba(0,33,98,.15);box-shadow:0 0 30px 0 rgba(0,33,98,.15)}.modal{-webkit-box-align:center;-ms-flex-align:center;align-items:center;display:none;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;overflow:hidden;position:fixed;z-index:40}.modal.is-active{display:-webkit-box;display:-ms-flexbox;display:flex}.modal-background{background-color:hsla(0,0%,100%,.5)}.modal-card,.modal-content{margin:0 20px;max-height:calc(100vh - 160px);overflow:auto;position:relative;width:100%}\@media print,screen and (min-width:769px){.modal-card,.modal-content{margin:0 auto;max-height:calc(100vh - 40px);width:640px}}.modal-close{background:none;height:40px;position:fixed;right:30px;top:30px;width:40px}.modal-card{-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;max-height:calc(100vh - 40px);overflow:hidden;-ms-overflow-y:visible}.modal-card,.modal-card-foot,.modal-card-head{display:-webkit-box;display:-ms-flexbox;display:flex}.modal-card-foot,.modal-card-head{-webkit-box-align:center;-ms-flex-align:center;align-items:center;background-color:#f5f5f6;-ms-flex-negative:0;flex-shrink:0;-webkit-box-pack:start;-ms-flex-pack:start;justify-content:flex-start;padding:20px;position:relative}.modal-card-head{border-bottom:1px solid #ebecec;border-top-left-radius:6px;border-top-right-radius:6px}.modal-card-title{color:#039;-webkit-box-flex:1;-ms-flex-positive:1;flex-grow:1;-ms-flex-negative:0;flex-shrink:0;font-size:1.125rem;line-height:1}.modal-card-foot{border-bottom-left-radius:6px;border-bottom-right-radius:6px;border-top:1px solid #ebecec}.modal-card-foot .button:not(:last-child){margin-right:.5em}.modal-card-body{-webkit-overflow-scrolling:touch;background-color:#fff;-webkit-box-flex:1;-ms-flex-positive:1;flex-grow:1;-ms-flex-negative:1;flex-shrink:1;overflow:auto;padding:20px}:host{display:block}.modal{-webkit-box-pack:start;-ms-flex-pack:start;justify-content:flex-start}.modal-content{margin-top:30px}.modal-content .box{margin:10px}.modal-content .box .title{margin-top:0}.modal-content .box p{margin:10px 0}.modal-close{position:absolute}.modal-close:after,.modal-close:before{background:#99add6}.modal-close:focus,.modal-close:hover{background:#f0fbff}"; }
};

exports.bal_modal = Modal;
