'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const core = require('./core-99ee4b4e.js');

const Toast = class {
    constructor(hostRef) {
        core.registerInstance(this, hostRef);
        this.animationClass = "fadeInDown";
        /**
         * The theme type of the toast. Given by bulma our css framework.
         */
        this.type = "is-primary";
    }
    /**
     * Closes the toast after the given duration in ms
     */
    async closeIn(duration) {
        this.timer = setTimeout(() => this.close(), duration);
    }
    /**
     * Closes this toast
     */
    async close() {
        clearTimeout(this.timer);
        this.animationClass = "fadeOut";
        this.timer = setTimeout(() => {
            this.element.remove();
            clearTimeout(this.timer);
        }, 150);
    }
    render() {
        return (core.h(core.Host, null, core.h("div", { role: "alert", onClick: () => this.close(), class: `toast ${this.animationClass} ${this.type}` }, this.message)));
    }
    get element() { return core.getElement(this); }
    static get style() { return "*{-webkit-box-sizing:border-box;box-sizing:border-box;-moz-osx-font-smoothing:grayscale;text-rendering:optimizeLegibility;-webkit-text-size-adjust:100%;-moz-text-size-adjust:100%}:host{position:relative;cursor:pointer}:host,:host .toast{display:-webkit-inline-box;display:-ms-inline-flexbox;display:inline-flex;-ms-flex-item-align:center;align-self:center}:host .toast{-webkit-animation-duration:.15s;animation-duration:.15s;margin:.5em 0;text-align:center;-webkit-box-shadow:0 1px 4px rgba(0,0,0,.12),0 0 6px rgba(0,0,0,.04);box-shadow:0 1px 4px rgba(0,0,0,.12),0 0 6px rgba(0,0,0,.04);border-radius:2em;padding:.75em 1.5em;pointer-events:auto;opacity:.92}:host .toast.is-primary{background:#009ee7;color:#fff}:host .toast.is-info{background:#039;color:#fff}:host .toast.is-success{background:#67d3a1;color:#fff}:host .toast.is-warning{background:#f90;color:#fff}:host .toast.is-danger{background:#f36;color:#fff}"; }
};

exports.bal_toast = Toast;
