import { Host, h } from "@stencil/core";
export class Modal {
    constructor() {
        this.isActive = false;
    }
    async open() {
        this.isActive = true;
    }
    async close() {
        this.isActive = false;
    }
    async handleKeyUp(event) {
        if (this.isActive) {
            if (event.key === "Escape" || event.key === "Esc") {
                event.preventDefault();
                this.close();
            }
        }
    }
    render() {
        return (h(Host, null,
            h("div", { class: [
                    "modal",
                    "is-clipped",
                    this.isActive ? "is-active" : "",
                ].join(" ") },
                h("div", { class: "modal-background" }),
                h("div", { class: "modal-content" },
                    h("div", { class: "box" },
                        h("div", { class: "section" },
                            h("slot", null)))))));
    }
    static get is() { return "bal-modal"; }
    static get encapsulation() { return "shadow"; }
    static get originalStyleUrls() { return {
        "$": ["modal.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["modal.css"]
    }; }
    static get states() { return {
        "isActive": {}
    }; }
    static get methods() { return {
        "open": {
            "complexType": {
                "signature": "() => Promise<void>",
                "parameters": [],
                "references": {
                    "Promise": {
                        "location": "global"
                    }
                },
                "return": "Promise<void>"
            },
            "docs": {
                "text": "",
                "tags": []
            }
        },
        "close": {
            "complexType": {
                "signature": "() => Promise<void>",
                "parameters": [],
                "references": {
                    "Promise": {
                        "location": "global"
                    }
                },
                "return": "Promise<void>"
            },
            "docs": {
                "text": "",
                "tags": []
            }
        }
    }; }
    static get listeners() { return [{
            "name": "keyup",
            "method": "handleKeyUp",
            "target": "body",
            "capture": false,
            "passive": false
        }]; }
}
