import { h, Host } from "@stencil/core";
export class Tag {
    constructor() {
        /**
         * The theme type of the tag. Given by bulma our css framework.
         */
        this.type = "is-light";
    }
    render() {
        return (h(Host, null,
            h("span", { class: `tag ${this.type}` },
                h("slot", null))));
    }
    static get is() { return "bal-tag"; }
    static get encapsulation() { return "shadow"; }
    static get originalStyleUrls() { return {
        "$": ["tag.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["tag.css"]
    }; }
    static get properties() { return {
        "type": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "| \"is-primary\"\n    | \"is-info\"\n    | \"is-success\"\n    | \"is-warning\"\n    | \"is-danger\"\n    | \"is-light\"",
                "resolved": "\"is-danger\" | \"is-info\" | \"is-light\" | \"is-primary\" | \"is-success\" | \"is-warning\"",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": "The theme type of the tag. Given by bulma our css framework."
            },
            "attribute": "type",
            "reflect": false,
            "defaultValue": "\"is-light\""
        }
    }; }
}
