var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { r as registerInstance, h, H as Host, g as getElement } from './core-45f50a11.js';
var DropdownOption = /** @class */ (function () {
    function class_1(hostRef) {
        registerInstance(this, hostRef);
        this.hidden = false;
        /**
         * The value of the dropdown item. This value will be returned by the parent <bal-dropdown> element.
         */
        this.value = false;
        /**
         * The value of the dropdown item. This value will be returned by the parent <bal-dropdown> element.
         */
        this.label = "";
        /**
         * TODO: Describe
         */
        this.activated = false;
        /**
         * TODO: Describe
         */
        this.highlight = "";
    }
    class_1.prototype.highlightChanged = function () {
        this.updateLabel();
    };
    /**
     * Tell's if the item is activated by selection.
     */
    class_1.prototype.isHidden = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.hidden];
            });
        });
    };
    class_1.prototype.componentDidLoad = function () {
        this.updateLabel();
    };
    Object.defineProperty(class_1.prototype, "parent", {
        get: function () {
            if (this.element.parentNode.tagName === "DIV") {
                // IE11 doesn't allow shadowing so we have tho navigate the dom up to the parent element.
                try {
                    return this.element.parentNode.parentNode.parentNode.parentNode;
                }
                catch (e) {
                    // Do nothing
                }
            }
            return this.element.parentNode;
        },
        enumerable: true,
        configurable: true
    });
    class_1.prototype.updateLabel = function () {
        if (this.highlight.length > 0) {
            var index = this.label.toLowerCase().indexOf(this.highlight.toLowerCase());
            this.hidden = index < 0;
            if (index >= 0) {
                this.labelElement.innerHTML = this.label.substring(0, index)
                    + "<span class='highlight'>"
                    + this.label.substring(index, index + this.highlight.length)
                    + "</span>"
                    + this.label.substring(index + this.highlight.length, this.label.length);
            }
        }
        else {
            this.labelElement.innerHTML = this.label;
        }
    };
    class_1.prototype.select = function () {
        return __awaiter(this, void 0, void 0, function () {
            var option;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        option = {
                            label: this.label,
                            value: this.value,
                        };
                        return [4 /*yield*/, this.parent.select(option)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    class_1.prototype.render = function () {
        var _this = this;
        return (h(Host, null, h("button", { class: [
                "dropdown-item",
                this.activated ? "is-active" : "",
                this.hidden ? "is-hidden" : "",
            ].join(" "), onClick: this.select.bind(this) }, h("span", { ref: function (el) { return _this.labelElement = el; } }, h("slot", null)))));
    };
    Object.defineProperty(class_1.prototype, "element", {
        get: function () { return getElement(this); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(class_1, "watchers", {
        get: function () {
            return {
                "highlight": ["highlightChanged"]
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(class_1, "style", {
        get: function () { return "*{-webkit-box-sizing:border-box;box-sizing:border-box;-moz-osx-font-smoothing:grayscale;text-rendering:optimizeLegibility;-webkit-text-size-adjust:100%;-moz-text-size-adjust:100%}.dropdown{display:-webkit-inline-box;display:-ms-inline-flexbox;display:inline-flex;position:relative;vertical-align:top}.dropdown.is-active .dropdown-menu,.dropdown.is-hoverable:hover .dropdown-menu{display:block}.dropdown.is-right .dropdown-menu{left:auto;right:0}.dropdown.is-up .dropdown-menu{bottom:100%;padding-bottom:4px;padding-top:0;top:auto}.dropdown-menu{display:none;left:0;min-width:18.75rem;padding-top:4px;position:absolute;top:100%;z-index:20}.dropdown-content{background-color:#fff;border-radius:0;-webkit-box-shadow:0 0 16px 0 rgba(0,33,98,.15);box-shadow:0 0 16px 0 rgba(0,33,98,.15);padding-bottom:14px;padding-top:14px}.dropdown-item{color:#039;display:block;font-size:.875rem;line-height:1.5;padding:.375rem 1rem;position:relative}a.dropdown-item,button.dropdown-item{padding-right:3rem;text-align:left;white-space:nowrap;width:100%}a.dropdown-item.is-active,a.dropdown-item:hover,button.dropdown-item.is-active,button.dropdown-item:hover{background-color:#f0fbff;color:#039}.dropdown-divider{background-color:#99add6;border:none;display:block;height:1px;margin:.5rem 0}:host{display:block}.highlight{font-weight:700}.dropdown-item{padding:10px 17px 13px 39px;-webkit-transition:padding-left .3s ease;transition:padding-left .3s ease;border:0;background:transparent;cursor:pointer}.dropdown-item.is-hidden{display:none}.dropdown-item span{font-family:MetaPro,Arial,sans-serif}.dropdown-item:focus,.dropdown-item:hover{background:#f0fbff}.dropdown-item.is-active{font-weight:700;background:#f0fbff}.dropdown-item:focus:not(.is-active),.dropdown-item:hover:not(.is-active){padding-left:49px}"; },
        enumerable: true,
        configurable: true
    });
    return class_1;
}());
export { DropdownOption as bal_dropdown_option };
