export declare class Button {
    /**
     * The theme type of the button. Given by bulma our css framework.
     */
    type: "is-primary" | "is-info" | "is-success" | "is-warning" | "is-danger" | "is-link";
    /**
     * If `true` the button is disabled
     */
    disabled: boolean;
    /**
     * If `true` the button has a light color
     */
    light: boolean;
    /**
     * If `true` the button has a full width
     */
    expanded: boolean;
    /**
     * If `true` the button is outlined
     */
    outlined: boolean;
    /**
     * If `true` the button is inverted
     */
    inverted: boolean;
    /**
     * If `true` the label is hidden and a loading spinner is shown instead.
     */
    loading: boolean;
    render(): any;
}
