import { r as registerInstance, h } from './core-45f50a11.js';
var Button = /** @class */ (function () {
    function Button(hostRef) {
        registerInstance(this, hostRef);
        /**
         * The theme type of the button. Given by bulma our css framework.
         */
        this.type = "is-primary";
    }
    Button.prototype.render = function () {
        return (h("button", { class: [
                "button",
                this.type,
                this.light ? "is-light" : "",
                this.inverted ? "is-inverted" : "",
                this.outlined ? "is-outlined" : "",
                this.expanded ? "is-fullwidth" : "",
                this.loading ? "is-loading" : "",
            ].join(" "), disabled: this.disabled }, this.loading ? (h("bal-spinner", { class: "is-small is-inverted" })) : (""), h("span", { style: { display: this.loading ? "none" : "inline-block" } }, h("slot", null))));
    };
    Object.defineProperty(Button, "style", {
        get: function () { return ".button{-webkit-touch-callout:none}.button.is-loading:after{-webkit-animation:spinAround .5s linear infinite;animation:spinAround .5s linear infinite;border:2px solid #ebecec;border-radius:290486px;border-right-color:transparent;border-top-color:transparent;content:\"\";display:block;height:1em;position:relative;width:1em}.button{-moz-appearance:none;-webkit-appearance:none;-webkit-box-align:center;-ms-flex-align:center;align-items:center;border:1px solid transparent;border-radius:4px;-webkit-box-shadow:none;box-shadow:none;display:-webkit-inline-box;display:-ms-inline-flexbox;display:inline-flex;font-size:.9375rem;height:2.5em;-webkit-box-pack:start;-ms-flex-pack:start;justify-content:flex-start;line-height:1.5;padding-left:calc(.75em - 1px);padding-right:calc(.75em - 1px);position:relative;vertical-align:top}.button:active,.button:focus,.is-active.button,.is-focused.button{outline:none}[disabled].button,fieldset[disabled] .button{cursor:not-allowed}*{-webkit-box-sizing:border-box;box-sizing:border-box;-moz-osx-font-smoothing:grayscale;text-rendering:optimizeLegibility;-webkit-text-size-adjust:100%;-moz-text-size-adjust:100%}.button{background-color:#fff;border-color:#ebecec;border-width:1px;color:#039;cursor:pointer;font-family:MetaPro,Arial,sans-serif;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;padding-bottom:calc(.5em - 1px);padding-left:30px;padding-right:30px;padding-top:calc(.5em - 1px);text-align:center;white-space:nowrap}.button strong{color:inherit}.button .icon,.button .icon.is-large,.button .icon.is-medium,.button .icon.is-small{height:1.5em;width:1.5em}.button .icon:first-child:not(:last-child){margin-left:calc(-15px - 1px);margin-right:7.5px}.button .icon:last-child:not(:first-child){margin-left:7.5px;margin-right:calc(-15px - 1px)}.button .icon:first-child:last-child{margin-left:calc(-15px - 1px);margin-right:calc(-15px - 1px)}.button.is-focused,.button.is-hovered,.button:focus,.button:hover{border-color:#039;color:#039}.button.is-focused:not(:active),.button:focus:not(:active){-webkit-box-shadow:0 0 0 0 transparent;box-shadow:0 0 0 0 transparent}.button.is-active,.button:active{border-color:#039;color:#039}.button.is-text{background-color:transparent;border-color:transparent;color:#222;text-decoration:underline}.button.is-text.is-focused,.button.is-text.is-hovered,.button.is-text:focus,.button.is-text:hover{background-color:#f5f5f6;color:#039}.button.is-text.is-active,.button.is-text:active{background-color:#e8e8ea;color:#039}.button.is-text[disabled],fieldset[disabled] .button.is-text{background-color:transparent;border-color:transparent;-webkit-box-shadow:none;box-shadow:none}.button.is-white{background-color:#fff;border-color:transparent;color:#222}.button.is-white.is-hovered,.button.is-white:hover{background-color:#f9f9f9;border-color:transparent;color:#222}.button.is-white.is-focused,.button.is-white:focus{border-color:transparent;color:#222}.button.is-white.is-focused:not(:active),.button.is-white:focus:not(:active){-webkit-box-shadow:0 0 0 0 hsla(0,0%,100%,.25);box-shadow:0 0 0 0 hsla(0,0%,100%,.25)}.button.is-white.is-active,.button.is-white:active{background-color:#f2f2f2;border-color:transparent;color:#222}.button.is-white[disabled],fieldset[disabled] .button.is-white{background-color:#fff;border-color:transparent;-webkit-box-shadow:none;box-shadow:none}.button.is-white.is-inverted{background-color:#222;color:#fff}.button.is-white.is-inverted.is-hovered,.button.is-white.is-inverted:hover{background-color:#151515}.button.is-white.is-inverted[disabled],fieldset[disabled] .button.is-white.is-inverted{background-color:#222;border-color:transparent;-webkit-box-shadow:none;box-shadow:none;color:#fff}.button.is-white.is-loading:after{border-color:transparent transparent #222 #222!important}.button.is-white.is-outlined{background-color:transparent;border-color:#fff;color:#fff}.button.is-white.is-outlined.is-focused,.button.is-white.is-outlined.is-hovered,.button.is-white.is-outlined:focus,.button.is-white.is-outlined:hover{background-color:#fff;border-color:#fff;color:#222}.button.is-white.is-outlined.is-loading:after{border-color:transparent transparent #fff #fff!important}.button.is-white.is-outlined.is-loading.is-focused:after,.button.is-white.is-outlined.is-loading.is-hovered:after,.button.is-white.is-outlined.is-loading:focus:after,.button.is-white.is-outlined.is-loading:hover:after{border-color:transparent transparent #222 #222!important}.button.is-white.is-outlined[disabled],fieldset[disabled] .button.is-white.is-outlined{background-color:transparent;border-color:#fff;-webkit-box-shadow:none;box-shadow:none;color:#fff}.button.is-white.is-inverted.is-outlined{background-color:transparent;border-color:#222;color:#222}.button.is-white.is-inverted.is-outlined.is-focused,.button.is-white.is-inverted.is-outlined.is-hovered,.button.is-white.is-inverted.is-outlined:focus,.button.is-white.is-inverted.is-outlined:hover{background-color:#222;color:#fff}.button.is-white.is-inverted.is-outlined.is-loading.is-focused:after,.button.is-white.is-inverted.is-outlined.is-loading.is-hovered:after,.button.is-white.is-inverted.is-outlined.is-loading:focus:after,.button.is-white.is-inverted.is-outlined.is-loading:hover:after{border-color:transparent transparent #fff #fff!important}.button.is-white.is-inverted.is-outlined[disabled],fieldset[disabled] .button.is-white.is-inverted.is-outlined{background-color:transparent;border-color:#222;-webkit-box-shadow:none;box-shadow:none;color:#222}.button.is-black{background-color:#222;border-color:transparent;color:#fff}.button.is-black.is-hovered,.button.is-black:hover{background-color:#1c1c1c;border-color:transparent;color:#fff}.button.is-black.is-focused,.button.is-black:focus{border-color:transparent;color:#fff}.button.is-black.is-focused:not(:active),.button.is-black:focus:not(:active){-webkit-box-shadow:0 0 0 0 rgba(34,34,34,.25);box-shadow:0 0 0 0 rgba(34,34,34,.25)}.button.is-black.is-active,.button.is-black:active{background-color:#151515;border-color:transparent;color:#fff}.button.is-black[disabled],fieldset[disabled] .button.is-black{background-color:#222;border-color:transparent;-webkit-box-shadow:none;box-shadow:none}.button.is-black.is-inverted{background-color:#fff;color:#222}.button.is-black.is-inverted.is-hovered,.button.is-black.is-inverted:hover{background-color:#f2f2f2}.button.is-black.is-inverted[disabled],fieldset[disabled] .button.is-black.is-inverted{background-color:#fff;border-color:transparent;-webkit-box-shadow:none;box-shadow:none;color:#222}.button.is-black.is-loading:after{border-color:transparent transparent #fff #fff!important}.button.is-black.is-outlined{background-color:transparent;border-color:#222;color:#222}.button.is-black.is-outlined.is-focused,.button.is-black.is-outlined.is-hovered,.button.is-black.is-outlined:focus,.button.is-black.is-outlined:hover{background-color:#222;border-color:#222;color:#fff}.button.is-black.is-outlined.is-loading:after{border-color:transparent transparent #222 #222!important}.button.is-black.is-outlined.is-loading.is-focused:after,.button.is-black.is-outlined.is-loading.is-hovered:after,.button.is-black.is-outlined.is-loading:focus:after,.button.is-black.is-outlined.is-loading:hover:after{border-color:transparent transparent #fff #fff!important}.button.is-black.is-outlined[disabled],fieldset[disabled] .button.is-black.is-outlined{background-color:transparent;border-color:#222;-webkit-box-shadow:none;box-shadow:none;color:#222}.button.is-black.is-inverted.is-outlined{background-color:transparent;border-color:#fff;color:#fff}.button.is-black.is-inverted.is-outlined.is-focused,.button.is-black.is-inverted.is-outlined.is-hovered,.button.is-black.is-inverted.is-outlined:focus,.button.is-black.is-inverted.is-outlined:hover{background-color:#fff;color:#222}.button.is-black.is-inverted.is-outlined.is-loading.is-focused:after,.button.is-black.is-inverted.is-outlined.is-loading.is-hovered:after,.button.is-black.is-inverted.is-outlined.is-loading:focus:after,.button.is-black.is-inverted.is-outlined.is-loading:hover:after{border-color:transparent transparent #222 #222!important}.button.is-black.is-inverted.is-outlined[disabled],fieldset[disabled] .button.is-black.is-inverted.is-outlined{background-color:transparent;border-color:#fff;-webkit-box-shadow:none;box-shadow:none;color:#fff}.button.is-light{background-color:#d8d9d9;border-color:transparent;color:rgba(0,0,0,.7)}.button.is-light.is-hovered,.button.is-light:hover{background-color:#d2d3d3;border-color:transparent;color:rgba(0,0,0,.7)}.button.is-light.is-focused,.button.is-light:focus{border-color:transparent;color:rgba(0,0,0,.7)}.button.is-light.is-focused:not(:active),.button.is-light:focus:not(:active){-webkit-box-shadow:0 0 0 0 rgba(216,217,217,.25);box-shadow:0 0 0 0 rgba(216,217,217,.25)}.button.is-light.is-active,.button.is-light:active{background-color:#cbcccc;border-color:transparent;color:rgba(0,0,0,.7)}.button.is-light[disabled],fieldset[disabled] .button.is-light{background-color:#d8d9d9;border-color:transparent;-webkit-box-shadow:none;box-shadow:none}.button.is-light.is-inverted{color:#d8d9d9}.button.is-light.is-inverted,.button.is-light.is-inverted.is-hovered,.button.is-light.is-inverted:hover{background-color:rgba(0,0,0,.7)}.button.is-light.is-inverted[disabled],fieldset[disabled] .button.is-light.is-inverted{background-color:rgba(0,0,0,.7);border-color:transparent;-webkit-box-shadow:none;box-shadow:none;color:#d8d9d9}.button.is-light.is-loading:after{border-color:transparent transparent rgba(0,0,0,.7) rgba(0,0,0,.7)!important}.button.is-light.is-outlined{background-color:transparent;border-color:#d8d9d9;color:#d8d9d9}.button.is-light.is-outlined.is-focused,.button.is-light.is-outlined.is-hovered,.button.is-light.is-outlined:focus,.button.is-light.is-outlined:hover{background-color:#d8d9d9;border-color:#d8d9d9;color:rgba(0,0,0,.7)}.button.is-light.is-outlined.is-loading:after{border-color:transparent transparent #d8d9d9 #d8d9d9!important}.button.is-light.is-outlined.is-loading.is-focused:after,.button.is-light.is-outlined.is-loading.is-hovered:after,.button.is-light.is-outlined.is-loading:focus:after,.button.is-light.is-outlined.is-loading:hover:after{border-color:transparent transparent rgba(0,0,0,.7) rgba(0,0,0,.7)!important}.button.is-light.is-outlined[disabled],fieldset[disabled] .button.is-light.is-outlined{background-color:transparent;border-color:#d8d9d9;-webkit-box-shadow:none;box-shadow:none;color:#d8d9d9}.button.is-light.is-inverted.is-outlined{background-color:transparent;border-color:rgba(0,0,0,.7);color:rgba(0,0,0,.7)}.button.is-light.is-inverted.is-outlined.is-focused,.button.is-light.is-inverted.is-outlined.is-hovered,.button.is-light.is-inverted.is-outlined:focus,.button.is-light.is-inverted.is-outlined:hover{background-color:rgba(0,0,0,.7);color:#d8d9d9}.button.is-light.is-inverted.is-outlined.is-loading.is-focused:after,.button.is-light.is-inverted.is-outlined.is-loading.is-hovered:after,.button.is-light.is-inverted.is-outlined.is-loading:focus:after,.button.is-light.is-inverted.is-outlined.is-loading:hover:after{border-color:transparent transparent #d8d9d9 #d8d9d9!important}.button.is-light.is-inverted.is-outlined[disabled],fieldset[disabled] .button.is-light.is-inverted.is-outlined{background-color:transparent;border-color:rgba(0,0,0,.7);-webkit-box-shadow:none;box-shadow:none;color:rgba(0,0,0,.7)}.button.is-dark{background-color:#039;border-color:transparent;color:#fff}.button.is-dark.is-hovered,.button.is-dark:hover{background-color:#002f8c;border-color:transparent;color:#fff}.button.is-dark.is-focused,.button.is-dark:focus{border-color:transparent;color:#fff}.button.is-dark.is-focused:not(:active),.button.is-dark:focus:not(:active){-webkit-box-shadow:0 0 0 0 rgba(0,51,153,.25);box-shadow:0 0 0 0 rgba(0,51,153,.25)}.button.is-dark.is-active,.button.is-dark:active{background-color:#002b80;border-color:transparent;color:#fff}.button.is-dark[disabled],fieldset[disabled] .button.is-dark{background-color:#039;border-color:transparent;-webkit-box-shadow:none;box-shadow:none}.button.is-dark.is-inverted{background-color:#fff;color:#039}.button.is-dark.is-inverted.is-hovered,.button.is-dark.is-inverted:hover{background-color:#f2f2f2}.button.is-dark.is-inverted[disabled],fieldset[disabled] .button.is-dark.is-inverted{background-color:#fff;border-color:transparent;-webkit-box-shadow:none;box-shadow:none;color:#039}.button.is-dark.is-loading:after{border-color:transparent transparent #fff #fff!important}.button.is-dark.is-outlined{background-color:transparent;border-color:#039;color:#039}.button.is-dark.is-outlined.is-focused,.button.is-dark.is-outlined.is-hovered,.button.is-dark.is-outlined:focus,.button.is-dark.is-outlined:hover{background-color:#039;border-color:#039;color:#fff}.button.is-dark.is-outlined.is-loading:after{border-color:transparent transparent #039 #039!important}.button.is-dark.is-outlined.is-loading.is-focused:after,.button.is-dark.is-outlined.is-loading.is-hovered:after,.button.is-dark.is-outlined.is-loading:focus:after,.button.is-dark.is-outlined.is-loading:hover:after{border-color:transparent transparent #fff #fff!important}.button.is-dark.is-outlined[disabled],fieldset[disabled] .button.is-dark.is-outlined{background-color:transparent;border-color:#039;-webkit-box-shadow:none;box-shadow:none;color:#039}.button.is-dark.is-inverted.is-outlined{background-color:transparent;border-color:#fff;color:#fff}.button.is-dark.is-inverted.is-outlined.is-focused,.button.is-dark.is-inverted.is-outlined.is-hovered,.button.is-dark.is-inverted.is-outlined:focus,.button.is-dark.is-inverted.is-outlined:hover{background-color:#fff;color:#039}.button.is-dark.is-inverted.is-outlined.is-loading.is-focused:after,.button.is-dark.is-inverted.is-outlined.is-loading.is-hovered:after,.button.is-dark.is-inverted.is-outlined.is-loading:focus:after,.button.is-dark.is-inverted.is-outlined.is-loading:hover:after{border-color:transparent transparent #039 #039!important}.button.is-dark.is-inverted.is-outlined[disabled],fieldset[disabled] .button.is-dark.is-inverted.is-outlined{background-color:transparent;border-color:#fff;-webkit-box-shadow:none;box-shadow:none;color:#fff}.button.is-primary{background-color:#009ee7;border-color:transparent;color:#fff}.button.is-primary.is-hovered,.button.is-primary:hover{background-color:#0095da;border-color:transparent;color:#fff}.button.is-primary.is-focused,.button.is-primary:focus{border-color:transparent;color:#fff}.button.is-primary.is-focused:not(:active),.button.is-primary:focus:not(:active){-webkit-box-shadow:0 0 0 0 rgba(0,158,231,.25);box-shadow:0 0 0 0 rgba(0,158,231,.25)}.button.is-primary.is-active,.button.is-primary:active{background-color:#008dce;border-color:transparent;color:#fff}.button.is-primary[disabled],fieldset[disabled] .button.is-primary{background-color:#009ee7;border-color:transparent;-webkit-box-shadow:none;box-shadow:none}.button.is-primary.is-inverted{background-color:#fff;color:#009ee7}.button.is-primary.is-inverted.is-hovered,.button.is-primary.is-inverted:hover{background-color:#f2f2f2}.button.is-primary.is-inverted[disabled],fieldset[disabled] .button.is-primary.is-inverted{background-color:#fff;border-color:transparent;-webkit-box-shadow:none;box-shadow:none;color:#009ee7}.button.is-primary.is-loading:after{border-color:transparent transparent #fff #fff!important}.button.is-primary.is-outlined{background-color:transparent;border-color:#009ee7;color:#009ee7}.button.is-primary.is-outlined.is-focused,.button.is-primary.is-outlined.is-hovered,.button.is-primary.is-outlined:focus,.button.is-primary.is-outlined:hover{background-color:#009ee7;border-color:#009ee7;color:#fff}.button.is-primary.is-outlined.is-loading:after{border-color:transparent transparent #009ee7 #009ee7!important}.button.is-primary.is-outlined.is-loading.is-focused:after,.button.is-primary.is-outlined.is-loading.is-hovered:after,.button.is-primary.is-outlined.is-loading:focus:after,.button.is-primary.is-outlined.is-loading:hover:after{border-color:transparent transparent #fff #fff!important}.button.is-primary.is-outlined[disabled],fieldset[disabled] .button.is-primary.is-outlined{background-color:transparent;border-color:#009ee7;-webkit-box-shadow:none;box-shadow:none;color:#009ee7}.button.is-primary.is-inverted.is-outlined{background-color:transparent;border-color:#fff;color:#fff}.button.is-primary.is-inverted.is-outlined.is-focused,.button.is-primary.is-inverted.is-outlined.is-hovered,.button.is-primary.is-inverted.is-outlined:focus,.button.is-primary.is-inverted.is-outlined:hover{background-color:#fff;color:#009ee7}.button.is-primary.is-inverted.is-outlined.is-loading.is-focused:after,.button.is-primary.is-inverted.is-outlined.is-loading.is-hovered:after,.button.is-primary.is-inverted.is-outlined.is-loading:focus:after,.button.is-primary.is-inverted.is-outlined.is-loading:hover:after{border-color:transparent transparent #009ee7 #009ee7!important}.button.is-primary.is-inverted.is-outlined[disabled],fieldset[disabled] .button.is-primary.is-inverted.is-outlined{background-color:transparent;border-color:#fff;-webkit-box-shadow:none;box-shadow:none;color:#fff}.button.is-primary.is-light{background-color:#ebf9ff;color:#0085c2}.button.is-primary.is-light.is-hovered,.button.is-primary.is-light:hover{background-color:#def5ff;border-color:transparent;color:#0085c2}.button.is-primary.is-light.is-active,.button.is-primary.is-light:active{background-color:#d1f0ff;border-color:transparent;color:#0085c2}.button.is-link{background-color:#009ee7;border-color:transparent;color:#039}.button.is-link.is-hovered,.button.is-link:hover{background-color:#0095da;border-color:transparent;color:#039}.button.is-link.is-focused,.button.is-link:focus{border-color:transparent;color:#039}.button.is-link.is-focused:not(:active),.button.is-link:focus:not(:active){-webkit-box-shadow:0 0 0 0 rgba(0,158,231,.25);box-shadow:0 0 0 0 rgba(0,158,231,.25)}.button.is-link.is-active,.button.is-link:active{background-color:#008dce;border-color:transparent;color:#039}.button.is-link[disabled],fieldset[disabled] .button.is-link{background-color:#009ee7;border-color:transparent;-webkit-box-shadow:none;box-shadow:none}.button.is-link.is-inverted{background-color:#039;color:#009ee7}.button.is-link.is-inverted.is-hovered,.button.is-link.is-inverted:hover{background-color:#002b80}.button.is-link.is-inverted[disabled],fieldset[disabled] .button.is-link.is-inverted{background-color:#039;border-color:transparent;-webkit-box-shadow:none;box-shadow:none;color:#009ee7}.button.is-link.is-loading:after{border-color:transparent transparent #039 #039!important}.button.is-link.is-outlined{background-color:transparent;border-color:#009ee7;color:#009ee7}.button.is-link.is-outlined.is-focused,.button.is-link.is-outlined.is-hovered,.button.is-link.is-outlined:focus,.button.is-link.is-outlined:hover{background-color:#009ee7;border-color:#009ee7;color:#039}.button.is-link.is-outlined.is-loading:after{border-color:transparent transparent #009ee7 #009ee7!important}.button.is-link.is-outlined.is-loading.is-focused:after,.button.is-link.is-outlined.is-loading.is-hovered:after,.button.is-link.is-outlined.is-loading:focus:after,.button.is-link.is-outlined.is-loading:hover:after{border-color:transparent transparent #039 #039!important}.button.is-link.is-outlined[disabled],fieldset[disabled] .button.is-link.is-outlined{background-color:transparent;border-color:#009ee7;-webkit-box-shadow:none;box-shadow:none;color:#009ee7}.button.is-link.is-inverted.is-outlined{background-color:transparent;border-color:#039;color:#039}.button.is-link.is-inverted.is-outlined.is-focused,.button.is-link.is-inverted.is-outlined.is-hovered,.button.is-link.is-inverted.is-outlined:focus,.button.is-link.is-inverted.is-outlined:hover{background-color:#039;color:#009ee7}.button.is-link.is-inverted.is-outlined.is-loading.is-focused:after,.button.is-link.is-inverted.is-outlined.is-loading.is-hovered:after,.button.is-link.is-inverted.is-outlined.is-loading:focus:after,.button.is-link.is-inverted.is-outlined.is-loading:hover:after{border-color:transparent transparent #009ee7 #009ee7!important}.button.is-link.is-inverted.is-outlined[disabled],fieldset[disabled] .button.is-link.is-inverted.is-outlined{background-color:transparent;border-color:#039;-webkit-box-shadow:none;box-shadow:none;color:#039}.button.is-link.is-light{background-color:#ebf9ff;color:#0085c2}.button.is-link.is-light.is-hovered,.button.is-link.is-light:hover{background-color:#def5ff;border-color:transparent;color:#0085c2}.button.is-link.is-light.is-active,.button.is-link.is-light:active{background-color:#d1f0ff;border-color:transparent;color:#0085c2}.button.is-info{background-color:#039;border-color:transparent;color:#fff}.button.is-info.is-hovered,.button.is-info:hover{background-color:#002f8c;border-color:transparent;color:#fff}.button.is-info.is-focused,.button.is-info:focus{border-color:transparent;color:#fff}.button.is-info.is-focused:not(:active),.button.is-info:focus:not(:active){-webkit-box-shadow:0 0 0 0 rgba(0,51,153,.25);box-shadow:0 0 0 0 rgba(0,51,153,.25)}.button.is-info.is-active,.button.is-info:active{background-color:#002b80;border-color:transparent;color:#fff}.button.is-info[disabled],fieldset[disabled] .button.is-info{background-color:#039;border-color:transparent;-webkit-box-shadow:none;box-shadow:none}.button.is-info.is-inverted{background-color:#fff;color:#039}.button.is-info.is-inverted.is-hovered,.button.is-info.is-inverted:hover{background-color:#f2f2f2}.button.is-info.is-inverted[disabled],fieldset[disabled] .button.is-info.is-inverted{background-color:#fff;border-color:transparent;-webkit-box-shadow:none;box-shadow:none;color:#039}.button.is-info.is-loading:after{border-color:transparent transparent #fff #fff!important}.button.is-info.is-outlined{background-color:transparent;border-color:#039;color:#039}.button.is-info.is-outlined.is-focused,.button.is-info.is-outlined.is-hovered,.button.is-info.is-outlined:focus,.button.is-info.is-outlined:hover{background-color:#039;border-color:#039;color:#fff}.button.is-info.is-outlined.is-loading:after{border-color:transparent transparent #039 #039!important}.button.is-info.is-outlined.is-loading.is-focused:after,.button.is-info.is-outlined.is-loading.is-hovered:after,.button.is-info.is-outlined.is-loading:focus:after,.button.is-info.is-outlined.is-loading:hover:after{border-color:transparent transparent #fff #fff!important}.button.is-info.is-outlined[disabled],fieldset[disabled] .button.is-info.is-outlined{background-color:transparent;border-color:#039;-webkit-box-shadow:none;box-shadow:none;color:#039}.button.is-info.is-inverted.is-outlined{background-color:transparent;border-color:#fff;color:#fff}.button.is-info.is-inverted.is-outlined.is-focused,.button.is-info.is-inverted.is-outlined.is-hovered,.button.is-info.is-inverted.is-outlined:focus,.button.is-info.is-inverted.is-outlined:hover{background-color:#fff;color:#039}.button.is-info.is-inverted.is-outlined.is-loading.is-focused:after,.button.is-info.is-inverted.is-outlined.is-loading.is-hovered:after,.button.is-info.is-inverted.is-outlined.is-loading:focus:after,.button.is-info.is-inverted.is-outlined.is-loading:hover:after{border-color:transparent transparent #039 #039!important}.button.is-info.is-inverted.is-outlined[disabled],fieldset[disabled] .button.is-info.is-inverted.is-outlined{background-color:transparent;border-color:#fff;-webkit-box-shadow:none;box-shadow:none;color:#fff}.button.is-info.is-light{background-color:#f0fbff;color:#002b82}.button.is-info.is-light.is-hovered,.button.is-info.is-light:hover{background-color:#e3f8ff;border-color:transparent;color:#002b82}.button.is-info.is-light.is-active,.button.is-info.is-light:active{background-color:#d7f4ff;border-color:transparent;color:#002b82}.button.is-success{background-color:#67d3a1;border-color:transparent;color:#fff}.button.is-success.is-hovered,.button.is-success:hover{background-color:#5dd09b;border-color:transparent;color:#fff}.button.is-success.is-focused,.button.is-success:focus{border-color:transparent;color:#fff}.button.is-success.is-focused:not(:active),.button.is-success:focus:not(:active){-webkit-box-shadow:0 0 0 0 rgba(103,211,161,.25);box-shadow:0 0 0 0 rgba(103,211,161,.25)}.button.is-success.is-active,.button.is-success:active{background-color:#53cd95;border-color:transparent;color:#fff}.button.is-success[disabled],fieldset[disabled] .button.is-success{background-color:#67d3a1;border-color:transparent;-webkit-box-shadow:none;box-shadow:none}.button.is-success.is-inverted{background-color:#fff;color:#67d3a1}.button.is-success.is-inverted.is-hovered,.button.is-success.is-inverted:hover{background-color:#f2f2f2}.button.is-success.is-inverted[disabled],fieldset[disabled] .button.is-success.is-inverted{background-color:#fff;border-color:transparent;-webkit-box-shadow:none;box-shadow:none;color:#67d3a1}.button.is-success.is-loading:after{border-color:transparent transparent #fff #fff!important}.button.is-success.is-outlined{background-color:transparent;border-color:#67d3a1;color:#67d3a1}.button.is-success.is-outlined.is-focused,.button.is-success.is-outlined.is-hovered,.button.is-success.is-outlined:focus,.button.is-success.is-outlined:hover{background-color:#67d3a1;border-color:#67d3a1;color:#fff}.button.is-success.is-outlined.is-loading:after{border-color:transparent transparent #67d3a1 #67d3a1!important}.button.is-success.is-outlined.is-loading.is-focused:after,.button.is-success.is-outlined.is-loading.is-hovered:after,.button.is-success.is-outlined.is-loading:focus:after,.button.is-success.is-outlined.is-loading:hover:after{border-color:transparent transparent #fff #fff!important}.button.is-success.is-outlined[disabled],fieldset[disabled] .button.is-success.is-outlined{background-color:transparent;border-color:#67d3a1;-webkit-box-shadow:none;box-shadow:none;color:#67d3a1}.button.is-success.is-inverted.is-outlined{background-color:transparent;border-color:#fff;color:#fff}.button.is-success.is-inverted.is-outlined.is-focused,.button.is-success.is-inverted.is-outlined.is-hovered,.button.is-success.is-inverted.is-outlined:focus,.button.is-success.is-inverted.is-outlined:hover{background-color:#fff;color:#67d3a1}.button.is-success.is-inverted.is-outlined.is-loading.is-focused:after,.button.is-success.is-inverted.is-outlined.is-loading.is-hovered:after,.button.is-success.is-inverted.is-outlined.is-loading:focus:after,.button.is-success.is-inverted.is-outlined.is-loading:hover:after{border-color:transparent transparent #67d3a1 #67d3a1!important}.button.is-success.is-inverted.is-outlined[disabled],fieldset[disabled] .button.is-success.is-inverted.is-outlined{background-color:transparent;border-color:#fff;-webkit-box-shadow:none;box-shadow:none;color:#fff}.button.is-success.is-light{background-color:#effaf5;color:#21734d}.button.is-success.is-light.is-hovered,.button.is-success.is-light:hover{background-color:#e5f8ef;border-color:transparent;color:#21734d}.button.is-success.is-light.is-active,.button.is-success.is-light:active{background-color:#dbf5e9;border-color:transparent;color:#21734d}.button.is-warning{background-color:#f90;border-color:transparent;color:#fff}.button.is-warning.is-hovered,.button.is-warning:hover{background-color:#f29100;border-color:transparent;color:#fff}.button.is-warning.is-focused,.button.is-warning:focus{border-color:transparent;color:#fff}.button.is-warning.is-focused:not(:active),.button.is-warning:focus:not(:active){-webkit-box-shadow:0 0 0 0 rgba(255,153,0,.25);box-shadow:0 0 0 0 rgba(255,153,0,.25)}.button.is-warning.is-active,.button.is-warning:active{background-color:#e68a00;border-color:transparent;color:#fff}.button.is-warning[disabled],fieldset[disabled] .button.is-warning{background-color:#f90;border-color:transparent;-webkit-box-shadow:none;box-shadow:none}.button.is-warning.is-inverted{background-color:#fff;color:#f90}.button.is-warning.is-inverted.is-hovered,.button.is-warning.is-inverted:hover{background-color:#f2f2f2}.button.is-warning.is-inverted[disabled],fieldset[disabled] .button.is-warning.is-inverted{background-color:#fff;border-color:transparent;-webkit-box-shadow:none;box-shadow:none;color:#f90}.button.is-warning.is-loading:after{border-color:transparent transparent #fff #fff!important}.button.is-warning.is-outlined{background-color:transparent;border-color:#f90;color:#f90}.button.is-warning.is-outlined.is-focused,.button.is-warning.is-outlined.is-hovered,.button.is-warning.is-outlined:focus,.button.is-warning.is-outlined:hover{background-color:#f90;border-color:#f90;color:#fff}.button.is-warning.is-outlined.is-loading:after{border-color:transparent transparent #f90 #f90!important}.button.is-warning.is-outlined.is-loading.is-focused:after,.button.is-warning.is-outlined.is-loading.is-hovered:after,.button.is-warning.is-outlined.is-loading:focus:after,.button.is-warning.is-outlined.is-loading:hover:after{border-color:transparent transparent #fff #fff!important}.button.is-warning.is-outlined[disabled],fieldset[disabled] .button.is-warning.is-outlined{background-color:transparent;border-color:#f90;-webkit-box-shadow:none;box-shadow:none;color:#f90}.button.is-warning.is-inverted.is-outlined{background-color:transparent;border-color:#fff;color:#fff}.button.is-warning.is-inverted.is-outlined.is-focused,.button.is-warning.is-inverted.is-outlined.is-hovered,.button.is-warning.is-inverted.is-outlined:focus,.button.is-warning.is-inverted.is-outlined:hover{background-color:#fff;color:#f90}.button.is-warning.is-inverted.is-outlined.is-loading.is-focused:after,.button.is-warning.is-inverted.is-outlined.is-loading.is-hovered:after,.button.is-warning.is-inverted.is-outlined.is-loading:focus:after,.button.is-warning.is-inverted.is-outlined.is-loading:hover:after{border-color:transparent transparent #f90 #f90!important}.button.is-warning.is-inverted.is-outlined[disabled],fieldset[disabled] .button.is-warning.is-inverted.is-outlined{background-color:transparent;border-color:#fff;-webkit-box-shadow:none;box-shadow:none;color:#fff}.button.is-warning.is-light{background-color:#fff7eb;color:#9e5f00}.button.is-warning.is-light.is-hovered,.button.is-warning.is-light:hover{background-color:#fff2de;border-color:transparent;color:#9e5f00}.button.is-warning.is-light.is-active,.button.is-warning.is-light:active{background-color:#ffedd1;border-color:transparent;color:#9e5f00}.button.is-danger{background-color:#f36;border-color:transparent;color:#fff}.button.is-danger.is-hovered,.button.is-danger:hover{background-color:#ff265c;border-color:transparent;color:#fff}.button.is-danger.is-focused,.button.is-danger:focus{border-color:transparent;color:#fff}.button.is-danger.is-focused:not(:active),.button.is-danger:focus:not(:active){-webkit-box-shadow:0 0 0 0 rgba(255,51,102,.25);box-shadow:0 0 0 0 rgba(255,51,102,.25)}.button.is-danger.is-active,.button.is-danger:active{background-color:#ff1a53;border-color:transparent;color:#fff}.button.is-danger[disabled],fieldset[disabled] .button.is-danger{background-color:#f36;border-color:transparent;-webkit-box-shadow:none;box-shadow:none}.button.is-danger.is-inverted{background-color:#fff;color:#f36}.button.is-danger.is-inverted.is-hovered,.button.is-danger.is-inverted:hover{background-color:#f2f2f2}.button.is-danger.is-inverted[disabled],fieldset[disabled] .button.is-danger.is-inverted{background-color:#fff;border-color:transparent;-webkit-box-shadow:none;box-shadow:none;color:#f36}.button.is-danger.is-loading:after{border-color:transparent transparent #fff #fff!important}.button.is-danger.is-outlined{background-color:transparent;border-color:#f36;color:#f36}.button.is-danger.is-outlined.is-focused,.button.is-danger.is-outlined.is-hovered,.button.is-danger.is-outlined:focus,.button.is-danger.is-outlined:hover{background-color:#f36;border-color:#f36;color:#fff}.button.is-danger.is-outlined.is-loading:after{border-color:transparent transparent #f36 #f36!important}.button.is-danger.is-outlined.is-loading.is-focused:after,.button.is-danger.is-outlined.is-loading.is-hovered:after,.button.is-danger.is-outlined.is-loading:focus:after,.button.is-danger.is-outlined.is-loading:hover:after{border-color:transparent transparent #fff #fff!important}.button.is-danger.is-outlined[disabled],fieldset[disabled] .button.is-danger.is-outlined{background-color:transparent;border-color:#f36;-webkit-box-shadow:none;box-shadow:none;color:#f36}.button.is-danger.is-inverted.is-outlined{background-color:transparent;border-color:#fff;color:#fff}.button.is-danger.is-inverted.is-outlined.is-focused,.button.is-danger.is-inverted.is-outlined.is-hovered,.button.is-danger.is-inverted.is-outlined:focus,.button.is-danger.is-inverted.is-outlined:hover{background-color:#fff;color:#f36}.button.is-danger.is-inverted.is-outlined.is-loading.is-focused:after,.button.is-danger.is-inverted.is-outlined.is-loading.is-hovered:after,.button.is-danger.is-inverted.is-outlined.is-loading:focus:after,.button.is-danger.is-inverted.is-outlined.is-loading:hover:after{border-color:transparent transparent #f36 #f36!important}.button.is-danger.is-inverted.is-outlined[disabled],fieldset[disabled] .button.is-danger.is-inverted.is-outlined{background-color:transparent;border-color:#fff;-webkit-box-shadow:none;box-shadow:none;color:#fff}.button.is-danger.is-light{background-color:#ffebf0;color:#db0037}.button.is-danger.is-light.is-hovered,.button.is-danger.is-light:hover{background-color:#ffdee6;border-color:transparent;color:#db0037}.button.is-danger.is-light.is-active,.button.is-danger.is-light:active{background-color:#ffd1dd;border-color:transparent;color:#db0037}.button.is-small{border-radius:4px;font-size:.8125rem}.button.is-normal{font-size:.9375rem}.button.is-medium{font-size:1.125rem}.button.is-large{font-size:1.375rem}.button[disabled],fieldset[disabled] .button{background-color:#fff;border-color:#ebecec;-webkit-box-shadow:none;box-shadow:none;opacity:.5}.button.is-fullwidth{display:-webkit-box;display:-ms-flexbox;display:flex;width:100%}.button.is-loading{color:transparent!important;pointer-events:none}.button.is-loading:after{position:absolute;left:calc(50% - (1em / 2));top:calc(50% - (1em / 2));position:absolute!important}.button.is-static{background-color:#f5f5f6;border-color:#ebecec;color:#d8d9d9;-webkit-box-shadow:none;box-shadow:none;pointer-events:none}.button.is-rounded{border-radius:290486px;padding-left:calc(30px + .25em);padding-right:calc(30px + .25em)}.buttons{-webkit-box-align:center;-ms-flex-align:center;align-items:center;display:-webkit-box;display:-ms-flexbox;display:flex;-ms-flex-wrap:wrap;flex-wrap:wrap;-webkit-box-pack:start;-ms-flex-pack:start;justify-content:flex-start}.buttons .button{margin-bottom:.5rem}.buttons .button:not(:last-child):not(.is-fullwidth){margin-right:.5rem}.buttons:last-child{margin-bottom:-.5rem}.buttons:not(:last-child){margin-bottom:1rem}.buttons.are-small .button:not(.is-normal):not(.is-medium):not(.is-large){border-radius:4px;font-size:.8125rem}.buttons.are-medium .button:not(.is-small):not(.is-normal):not(.is-large){font-size:1.125rem}.buttons.are-large .button:not(.is-small):not(.is-normal):not(.is-medium){font-size:1.375rem}.buttons.has-addons .button:not(:first-child){border-bottom-left-radius:0;border-top-left-radius:0}.buttons.has-addons .button:not(:last-child){border-bottom-right-radius:0;border-top-right-radius:0;margin-right:-1px}.buttons.has-addons .button:last-child{margin-right:0}.buttons.has-addons .button.is-hovered,.buttons.has-addons .button:hover{z-index:2}.buttons.has-addons .button.is-active,.buttons.has-addons .button.is-focused,.buttons.has-addons .button.is-selected,.buttons.has-addons .button:active,.buttons.has-addons .button:focus{z-index:3}.buttons.has-addons .button.is-active:hover,.buttons.has-addons .button.is-focused:hover,.buttons.has-addons .button.is-selected:hover,.buttons.has-addons .button:active:hover,.buttons.has-addons .button:focus:hover{z-index:4}.buttons.has-addons .button.is-expanded{-webkit-box-flex:1;-ms-flex-positive:1;flex-grow:1;-ms-flex-negative:1;flex-shrink:1}.buttons.is-centered{-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center}.buttons.is-centered:not(.has-addons) .button:not(.is-fullwidth){margin-left:.25rem;margin-right:.25rem}.buttons.is-right{-webkit-box-pack:end;-ms-flex-pack:end;justify-content:flex-end}.buttons.is-right:not(.has-addons) .button:not(.is-fullwidth){margin-left:.25rem;margin-right:.25rem}.button{-webkit-transition:.2s ease-in-out;transition:.2s ease-in-out;outline:none!important;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;min-height:50px}.button.is-loading:after{display:none}.button::-moz-focus-inner{border:0}.button:focus:before{position:absolute;content:\"\";top:2px;left:2px;right:2px;bottom:2px;outline:2px dashed #009ee7}.button:active:before,.button:hover:before{outline:none}.button.is-primary.is-active,.button.is-primary.is-focused,.button.is-primary.is-hovered,.button.is-primary:active,.button.is-primary:focus,.button.is-primary:hover{background:#039}.button.is-info.is-hovered,.button.is-info:hover{background:#009ee7}.button.is-success.is-hovered,.button.is-success:hover{background:#35b87c}.button.is-warning.is-hovered,.button.is-warning:hover{background:#cc7a00}.button.is-danger.is-hovered,.button.is-danger:hover{background:#c03}.button.is-success,.button.is-success.is-active,.button.is-success.is-focused,.button.is-success.is-hovered,.button.is-success.is-outlined.is-active,.button.is-success.is-outlined.is-focused,.button.is-success.is-outlined.is-hovered,.button.is-success.is-outlined:active,.button.is-success.is-outlined:focus,.button.is-success.is-outlined:hover,.button.is-success:active,.button.is-success:focus,.button.is-success:hover,.button.is-warning,.button.is-warning.is-active,.button.is-warning.is-focused,.button.is-warning.is-hovered,.button.is-warning.is-outlined.is-active,.button.is-warning.is-outlined.is-focused,.button.is-warning.is-outlined.is-hovered,.button.is-warning.is-outlined:active,.button.is-warning.is-outlined:focus,.button.is-warning.is-outlined:hover,.button.is-warning:active,.button.is-warning:focus,.button.is-warning:hover{color:#fff}.button.is-primary.is-inverted{background:#009ee7;color:#fff}.button.is-primary.is-inverted.is-active,.button.is-primary.is-inverted.is-focused,.button.is-primary.is-inverted.is-hovered,.button.is-primary.is-inverted:active,.button.is-primary.is-inverted:focus,.button.is-primary.is-inverted:hover{color:#039;background:#fff}.button.is-info.is-outlined{border-color:#99add6}.button.is-info.is-outlined.is-active,.button.is-info.is-outlined.is-focused,.button.is-info.is-outlined.is-hovered,.button.is-info.is-outlined:active,.button.is-info.is-outlined:focus,.button.is-info.is-outlined:hover{color:#039;background:#d3dbeb;border-color:#99add6}.button.is-info.is-inverted.is-outlined.is-active,.button.is-info.is-inverted.is-outlined.is-focused,.button.is-info.is-inverted.is-outlined.is-hovered,.button.is-info.is-inverted.is-outlined:active,.button.is-info.is-inverted.is-outlined:focus,.button.is-info.is-inverted.is-outlined:hover{color:#fff;background:#026}.button.is-info.is-inverted.is-active,.button.is-info.is-inverted.is-focused,.button.is-info.is-inverted.is-hovered,.button.is-info.is-inverted:active,.button.is-info.is-inverted:focus,.button.is-info.is-inverted:hover{color:#fff;background:#009ee7}.button.is-link{color:#009ee7;background:transparent}.button.is-link.is-active,.button.is-link.is-focused,.button.is-link.is-hovered,.button.is-link:active,.button.is-link:focus,.button.is-link:hover{color:#039;background:transparent;text-decoration:underline}.button.is-primary.is-light{border:none;border-radius:0;color:#039;background:#f0fbff}.button.is-primary.is-light.is-active,.button.is-primary.is-light.is-focused,.button.is-primary.is-light.is-hovered,.button.is-primary.is-light:active,.button.is-primary.is-light:focus,.button.is-primary.is-light:hover{color:#039;background:#ebf6fa}.button.is-info.is-light{border:none;border-radius:0}.button.is-info.is-light,.button.is-info.is-light.is-active,.button.is-info.is-light.is-focused,.button.is-info.is-light.is-hovered,.button.is-info.is-light:active,.button.is-info.is-light:focus,.button.is-info.is-light:hover{color:#039;background:transparent}.button[disabled].is-link{text-decoration:none;color:#009ee7;background:transparent}.button[disabled].is-active.is-primary,.button[disabled].is-focused.is-primary,.button[disabled].is-hovered.is-primary,.button[disabled]:active.is-primary,.button[disabled]:focus.is-primary,.button[disabled]:hover.is-primary{color:#fff;background:#009ee7}.button[disabled].is-active.is-info,.button[disabled].is-focused.is-info,.button[disabled].is-hovered.is-info,.button[disabled]:active.is-info,.button[disabled]:focus.is-info,.button[disabled]:hover.is-info{color:#fff;background:#039}.button[disabled].is-active.is-warning,.button[disabled].is-focused.is-warning,.button[disabled].is-hovered.is-warning,.button[disabled]:active.is-warning,.button[disabled]:focus.is-warning,.button[disabled]:hover.is-warning{color:#fff;background:#ff8304}.button[disabled].is-active.is-danger,.button[disabled].is-focused.is-danger,.button[disabled].is-hovered.is-danger,.button[disabled]:active.is-danger,.button[disabled]:focus.is-danger,.button[disabled]:hover.is-danger{color:#fff;background:#f36}.button[disabled].is-active.is-success,.button[disabled].is-focused.is-success,.button[disabled].is-hovered.is-success,.button[disabled]:active.is-success,.button[disabled]:focus.is-success,.button[disabled]:hover.is-success{color:#fff;background:#67d3a1}.button[disabled].is-active.is-link,.button[disabled].is-focused.is-link,.button[disabled].is-hovered.is-link,.button[disabled]:active.is-link,.button[disabled]:focus.is-link,.button[disabled]:hover.is-link{text-decoration:none;color:#009ee7;background:transparent}.button span{line-height:1.25rem;font-weight:600}"; },
        enumerable: true,
        configurable: true
    });
    return Button;
}());
export { Button as bal_button };
